/// <reference types="react-reconciler" />
import * as THREE from 'three';
import * as React from 'react';
import { StoreProps, context, RootState } from '../core/store';
import { extend } from '../core/renderer';
import { Canvas } from './Canvas';
export declare type RenderProps = Omit<StoreProps, 'gl' | 'context'> & {
    gl?: THREE.WebGLRenderer | THREE.WebGLRendererParameters;
    concurrent?: boolean;
};
declare const invalidate: (state?: RootState | undefined) => void;
declare const reconciler: import("react-reconciler").Reconciler<unknown, unknown, unknown, unknown, unknown>, applyProps: (instance: import("../core/renderer").Instance, newProps: import("../core/renderer").InstanceProps, oldProps?: import("../core/renderer").InstanceProps, accumulative?: boolean) => void;
declare function render(element: React.ReactNode, canvas: HTMLCanvasElement, { gl, size, concurrent, ...props }?: RenderProps): THREE.Scene;
declare function unmountComponentAtNode(canvas: HTMLCanvasElement, callback?: (canvas: HTMLCanvasElement) => void): void;
declare function createPortal(children: React.ReactNode, container: any, impl?: any, key?: any): React.ReactNode;
declare const testutil_act: (callback: () => import("react-reconciler").Thenable<unknown>) => import("react-reconciler").Thenable<void>;
export * from '../core/hooks';
export { context, render, unmountComponentAtNode, createPortal, reconciler, applyProps, invalidate, extend, Canvas, testutil_act, };
